;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;Horizontal flip
; PRINT USR HFLP
;================================

@DFile=400C
@Table1=403C			;PRBuff1, Table1 addr
@Table2=403E			;PRBuff2, Table2 addr

	JR HFlip
;================================
;Table1
	00 02 01 03 87 85 86 84
;Table2
	80 82 81 83 07 05 06 04
;================================
@HFLIP
	LD HL,0002
	ADD HL,BC		;Table1 address
	LD (Table1),HL		;Store Table1 Address
	LD BC,0008
	ADD HL,BC		;Table2 address
	LD (Table2),HL		;Store Table2 Address
	LD HL,(DFile)
	LD C,10 
	ADD HL,BC
	LD D,H 
	LD E,L 
	INC DE 
	LD B,18 
@LoopA
	LD A,(HL) 
	BIT 6,A			;N/L test
	JR NZ Skip76		;Jump if N/L chr
	EX DE,HL 
	LD C,(HL) 
	LD (HL),A 
	EX DE,HL 
	LD (HL),C 
	DEC HL 
	INC DE 
	JR LoopA
@Skip76
	LD DE,0031 
	ADD HL,DE 
	LD D,H 
	LD E,L 
	INC DE 
	DJNZ LoopA
;================================
;This section will properly "flip"
;the pixel characters.
;================================
	LD HL,(DFile)
	LD BC,0318		;Counter=792=DFILE size
@LoopB
	PUSH BC
	INC HL
	LD A,(HL)		;Get character
	BIT 7,A			;Character code>=128?
	LD DE,(Table1)		;Use Table1
	JR Z +5			;Jump if code<128
	SUB 80
	LD DE,(Table2)		;Use Table2
	AND A			;Test for 0
	JR Z Next		;Jump if 0, no flip needed
	LD B,00			;Test for valid pixel code
	LD C,A
	SUB 08
	JR NC Next		;Jump if A>8, not a valid pixel chr
	EX DE,HL		;HL=Table
	ADD HL,BC		;Add offset to table
	LD A,(HL)		;A=Flipped pixel character
	EX DE,HL		;HL=DFILE addr
	LD (HL),A		;Print flipped character
@Next
	POP BC			;POP counter
	DEC BC			;Decrease counter
	LD A,B 
	OR C
	JR NZ LoopB		;Jump if BC<>0
	RST 08
	FF

	