;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;     Vertical Flip
;          By
;      Greg Harder
;================================

@DFile=400C			;Start of D-FILE
@Vars=4010
@PRBuff=403C			;Line storage
@Line1=4036			;Coords, Line1 addr
@Line2=407B			;Spare2, Line2 addr
@Table1=4036			;Coords, Table1 addr
@Table2=407B			;Spare2, Table2 addr

	JR VFlip
;================================
;Table1
	00 04 87 83 01 05 86 82 88 0A 09
;Table2
	80 84 07 03 81 85 06 02 08 8A 89
;================================
@VFlip
	PUSH BC			;Push USR Addr
	LD HL,(DFile)		;Start of DFile
	INC HL
	LD (Line1),HL		;Save Line1 addr
	LD BC,0021
	LD HL,(Vars)
	XOR A
	SBC HL,BC		;HL=Line2 addr
	LD B,0C			;Row counter
@LoopA
	PUSH BC			;PUSH counter
	LD (Line2),HL		;Save Line2 addr
	LD HL,(LINE1)
	LD DE,PRBuff
	LD BC,0020
	LDIR			;Copy Line1 to storage area
	LD HL,(Line1)
	EX DE,HL
	LD HL,(Line2)
	LD C,20
	LDIR			;Copy Line2 to Line1
	INC DE			;Start of next line
	LD (Line1),DE		;Save Line addr
	LD HL,PRBuff
	LD DE,(Line2)
	LD C,20
	LDIR			;Copy Line1 to Line2
	LD C,21
	LD HL,(Line2)
	XOR A
	SBC HL,BC		;HL=Next Line
	POP BC			;POP row counter
	DJNZ LoopA		;Loop until B=0
;================================
;This section "flips" the pixel
;and graphic characters.
;================================
	POP BC			;POP USR Addr
	LD HL,0002
	ADD HL,BC		;Table1 address
	LD (Table1),HL		;Store Table1 Address
	LD BC,000B
	ADD HL,BC		;Table2 address
	LD (Table2),HL		;Store Table2 Address
	LD HL,(DFile)
	LD BC,0318		;Byte counter=792
@LoopB
	PUSH BC
	INC HL
	LD A,(HL)		;Get character
	BIT 7,A			;Character code>=128?
	LD DE,(Table1)		;Use Table1
	JR Z +5
	SUB 80
	LD DE,(Table2)		;Use Table2
	AND A			;Test for 0
	JR Z Next		;Jump if 0, no flip needed
	LD B,00			;Test for valid pixel code
	LD C,A
	SUB 0B
	JR NC Next		;IF A>10 THEN not a valid pixel
	EX DE,HL		;HL=Table
	ADD HL,BC		;Add offset to table
	LD A,(HL)		;A=Flipped pixel character
	EX DE,HL		;HL=DFile addr
	LD (HL),A		;Print flipped character
@Next
	POP BC			;POP counter
	DEC BC			;Decrease counter
	LD A,B 
	OR C
	JR NZ LoopB		;Loop until byte counter=0
	RST 08
	FF

	
